package Binary_Search
  with SPARK_Mode
is
   type Opt_Index is new Natural;
   subtype Index is Opt_Index range 1 .. Opt_Index'Last - 1;
   No_Index : constant Opt_Index := 0;
   type Arr is array(Index range <>) of Integer;

   function Sorted(A : Arr) return Boolean is
      (for all I in A'Range =>
         (for all J in I .. A'Last => A (I) <= A (J)));

   function Search(A : Arr; V : Integer) return Opt_Index with
     Pre  => Sorted(A),
     Post => 
         (if Search'Result in A'Range then A(Search'Result) = V
          else (for all I in A'Range => A(I) /= V));

end Binary_Search;
