(* This file is generated by Why3's Coq driver *)
(* Beware! Only edit allowed sections below    *)
Require Import BuiltIn.
Require BuiltIn.
Require int.Int.
Require int.MinMax.
Require list.List.
Require list.Length.
Require list.Mem.
Require option.Option.
Require list.Append.

(* Why3 assumption *)
Definition unit := unit.

Axiom filename : Type.
Parameter filename_WhyType : WhyType filename.
Existing Instance filename_WhyType.

(* Why3 assumption *)
Inductive pathcomponent :=
  | Down : filename -> pathcomponent
  | Up : pathcomponent
  | Here : pathcomponent.
Axiom pathcomponent_WhyType : WhyType pathcomponent.
Existing Instance pathcomponent_WhyType.

(* Why3 assumption *)
Definition path := (list pathcomponent).

Axiom dirnode : Type.
Parameter dirnode_WhyType : WhyType dirnode.
Existing Instance dirnode_WhyType.

(* Why3 assumption *)
Inductive child :=
  | Absent : child
  | Dir : dirnode -> child
  | AbsLink : (list pathcomponent) -> child
  | RelLink : (list pathcomponent) -> child.
Axiom child_WhyType : WhyType child.
Existing Instance child_WhyType.

Parameter root: dirnode.

Parameter lookup: dirnode -> filename -> child.

Parameter parent: dirnode -> dirnode.

Axiom parent_root : ((parent root) = root).

Axiom parent_non_root : forall (d1:dirnode) (f:filename) (d2:dirnode),
  ((lookup d1 f) = (Dir d2)) -> ((parent d2) = d1).

(* Why3 assumption *)
Inductive resolve_to: dirnode -> (list pathcomponent) -> dirnode -> Prop :=
  | ResolveNil : forall (d:dirnode), (resolve_to d Init.Datatypes.nil d)
  | ResolveDir : forall (d1:dirnode) (fn:filename) (d2:dirnode)
      (p:(list pathcomponent)) (d3:dirnode), ((lookup d1 fn) = (Dir d2)) ->
      ((resolve_to d2 p d3) -> (resolve_to d1
      (Init.Datatypes.cons (Down fn) p) d3))
  | ResolveAbsLink : forall (d1:dirnode) (fn:filename)
      (ps:(list pathcomponent)) (pr:(list pathcomponent)) (d2:dirnode)
      (d3:dirnode), ((lookup d1 fn) = (AbsLink ps)) -> ((resolve_to root ps
      d2) -> ((resolve_to d2 pr d3) -> (resolve_to d1
      (Init.Datatypes.cons (Down fn) pr) d3)))
  | ResolveRelLink : forall (d1:dirnode) (fn:filename)
      (ps:(list pathcomponent)) (pr:(list pathcomponent)) (d2:dirnode)
      (d3:dirnode), ((lookup d1 fn) = (RelLink ps)) -> ((resolve_to d1 ps
      d2) -> ((resolve_to d2 pr d3) -> (resolve_to d1
      (Init.Datatypes.cons (Down fn) pr) d3)))
  | ResolveUp : forall (d1:dirnode) (d2:dirnode) (d3:dirnode)
      (p:(list pathcomponent)), ((parent d1) = d2) -> ((resolve_to d2 p
      d3) -> (resolve_to d1 (Init.Datatypes.cons Up p) d3))
  | ResolveHere : forall (d1:dirnode) (p:(list pathcomponent)) (d2:dirnode),
      (resolve_to d1 p d2) -> (resolve_to d1 (Init.Datatypes.cons Here p) d2).

(* Why3 assumption *)
Inductive resolve_with_height: dirnode -> (list pathcomponent) ->
  (option (dirnode* Z)%type) -> Prop :=
  | ResolveHeightAbsent : forall (d:dirnode) (p:(list pathcomponent)),
      (forall (d1:dirnode), ~ (resolve_to d p d1)) -> (resolve_with_height d
      p Init.Datatypes.None)
  | ResolveHeightNil : forall (d:dirnode), (resolve_with_height d
      Init.Datatypes.nil (Init.Datatypes.Some (d, 0%Z)))
  | ResolveHeightDir : forall (d1:dirnode) (fn:filename) (d2:dirnode)
      (p:(list pathcomponent)) (d3:dirnode) (h:Z), ((lookup d1
      fn) = (Dir d2)) -> ((resolve_with_height d2 p (Init.Datatypes.Some (d3,
      h))) -> (resolve_with_height d1 (Init.Datatypes.cons (Down fn) p)
      (Init.Datatypes.Some (d3, (h + 1%Z)%Z))))
  | ResolveHeightAbsLink : forall (d1:dirnode) (fn:filename)
      (ps:(list pathcomponent)) (pr:(list pathcomponent)) (d2:dirnode)
      (d3:dirnode) (h1:Z) (h2:Z), ((lookup d1 fn) = (AbsLink ps)) ->
      ((resolve_with_height root ps (Init.Datatypes.Some (d2, h1))) ->
      ((resolve_with_height d2 pr (Init.Datatypes.Some (d3, h2))) ->
      (resolve_with_height d1 (Init.Datatypes.cons (Down fn) pr)
      (Init.Datatypes.Some (d3, ((ZArith.BinInt.Z.max h1 h2) + 1%Z)%Z)))))
  | ResolveHeightRelLink : forall (d1:dirnode) (fn:filename)
      (ps:(list pathcomponent)) (pr:(list pathcomponent)) (d2:dirnode)
      (d3:dirnode) (h1:Z) (h2:Z), ((lookup d1 fn) = (RelLink ps)) ->
      ((resolve_with_height d1 ps (Init.Datatypes.Some (d2, h1))) ->
      ((resolve_with_height d2 pr (Init.Datatypes.Some (d3, h2))) ->
      (resolve_with_height d1 (Init.Datatypes.cons (Down fn) pr)
      (Init.Datatypes.Some (d3, ((ZArith.BinInt.Z.max h1 h2) + 1%Z)%Z)))))
  | ResolveHeightUp : forall (d1:dirnode) (d2:dirnode) (d3:dirnode)
      (p:(list pathcomponent)) (h:Z), ((parent d1) = d2) ->
      ((resolve_with_height d2 p (Init.Datatypes.Some (d3, h))) ->
      (resolve_with_height d1 (Init.Datatypes.cons Up p)
      (Init.Datatypes.Some (d3, (h + 1%Z)%Z))))
  | ResolveHeightHere : forall (d1:dirnode) (p:(list pathcomponent))
      (d2:dirnode) (h:Z), (resolve_with_height d1 p (Init.Datatypes.Some (d2,
      h))) -> (resolve_with_height d1 (Init.Datatypes.cons Here p)
      (Init.Datatypes.Some (d2, (h + 1%Z)%Z))).

Axiom resolve_height_resolve : forall (d1:dirnode) (p:(list pathcomponent))
  (d2:dirnode) (h:Z), (resolve_with_height d1 p (Init.Datatypes.Some (d2,
  h))) -> (resolve_to d1 p d2).

Axiom resolve_height_pos : forall (d1:dirnode) (p:(list pathcomponent))
  (d2:dirnode) (h:Z), (resolve_with_height d1 p (Init.Datatypes.Some (d2,
  h))) -> (0%Z <= h)%Z.

Axiom resolve_make_height : forall (d1:dirnode) (p:(list pathcomponent))
  (d2:dirnode), (resolve_to d1 p d2) -> exists h:Z, (resolve_with_height d1 p
  (Init.Datatypes.Some (d2, h))).

Axiom resolve_to_append : forall (d1:dirnode) (d2:dirnode) (d3:dirnode)
  (p:(list pathcomponent)) (q:(list pathcomponent)), (resolve_to d1 p d2) ->
  ((resolve_to d2 q d3) -> (resolve_to d1 (Init.Datatypes.app p q) d3)).

Axiom resolve_to_cons : forall (d1:dirnode) (d2:dirnode) (d3:dirnode)
  (c:pathcomponent) (p:(list pathcomponent)), (resolve_to d1
  (Init.Datatypes.cons c Init.Datatypes.nil) d2) -> ((resolve_to d2 p d3) ->
  (resolve_to d1 (Init.Datatypes.cons c p) d3)).

Axiom resolve_to_decomp : forall (d1:dirnode) (d3:dirnode) (c:pathcomponent)
  (p2:(list pathcomponent)), (resolve_to d1 (Init.Datatypes.cons c p2) d3) ->
  exists d2:dirnode, (resolve_to d1
  (Init.Datatypes.cons c Init.Datatypes.nil) d2) /\ (resolve_to d2 p2 d3).

(* Why3 goal *)
Theorem WP_parameter_resolve_to_decomposition : forall (p1:(list pathcomponent)),
  forall (x:pathcomponent) (x1:(list pathcomponent)),
  (p1 = (Init.Datatypes.cons x x1)) -> ((forall (p2:(list pathcomponent))
  (d1:dirnode) (d3:dirnode), (resolve_to d1 (Init.Datatypes.app x1 p2) d3) ->
  exists d2:dirnode, (resolve_to d1 x1 d2) /\ (resolve_to d2 p2 d3)) ->
  forall (p2:(list pathcomponent)) (d1:dirnode) (d3:dirnode), (resolve_to d1
  (Init.Datatypes.app p1 p2) d3) -> exists d2:dirnode, (resolve_to d1 p1
  d2) /\ (resolve_to d2 p2 d3)).
(* Why3 intros p1 x x1 h1 h2 p2 d1 d3 h3. *)
intros p1 x x1 h1 h2 p2 d1 d3 h3.
subst p1.
simpl in h3.
(* Require Import Why3.
why3 "cvc4" timelimit 3. *)
destruct (resolve_to_decomp _ _ _ _ h3) as (d2 & h4 & h5).
destruct (h2 _ _ _ h5) as (d4 & h6 & h7).
exists d4.
split; auto.
apply resolve_to_cons with d2; auto.
(*
replace (x :: x1)%list with ((x :: nil) ++ x1)%list by auto.
apply resolve_to_append with d2; auto.
*)
Qed.

