
package Body Pe11_Max4 is

   function Max_Product_4 (M: Matrix) return Long_Integer is
      Cur_Max : Long_Integer := Right_Diag (M, M'First (1), M'First (2));
      -- Current position (Cur_I, Cur_J) and direction D always resulting
      -- in a product equal to Cur_max
      Cur_I : Integer range M'Range(1) := M'First (1) with Ghost;
      Cur_J : Integer range M'Range(2) := M'First(2) with Ghost;
      D: Direction := RD with Ghost;
   begin
      for I in M'Range (1) loop
	 -- Loop_invariant: Current max should be accessible by an already
	 -- attained (Cur_I, Cur_J, D)
	 pragma Loop_Invariant (Is_Valid (M, Cur_I, Cur_J, D));
         pragma Loop_Invariant (Mult_Value (M, Cur_I, Cur_J, D) = Cur_Max);

	 -- Loop_invariant: Current max should be greater than each already
	 -- accessed product ie all (I', J, D) with I' < I, and for all J and D
	 pragma Loop_Invariant
	   (for all K in M'First (1) .. (I - 1) =>
             (for all L in M'Range (2) =>
                (for all D1 in Direction =>
                   (if Is_Valid (M, K, L, D1) then Cur_Max >= Mult_Value (M, K, L, D1)))));

	 for J in M'Range (2) loop
	    -- Loop_invariant: Current max should be accessible by an already
            -- attained (Cur_I, Cur_J, D)
            pragma Loop_Invariant (Is_Valid (M, Cur_I, Cur_J, D));
            pragma Loop_Invariant (Mult_Value (M, Cur_I, Cur_J, D) = Cur_Max);

	    -- Loop_invariant: Current max should be greater than each already
            -- accessed product:  all (I', J', D) with I' < I for all J' and D
            -- or I' = I and J' < J for all D
	    pragma Loop_Invariant
	      (for all K in M'First (1) .. I =>
                 (for all L in M'Range (2) =>
                   (for all D1 in Direction =>
                      (if K < I or L < J then
                        (if Is_Valid (M, K, L, D1) then Cur_Max >= Mult_Value (M, K, L, D1))))));
	    -- Checking of the 4 directions
	    -- Right_diag
	    if (I + 3 <= M'Last (1) and J + 3 <= M'Last (2)) then
               if (Right_Diag(M, I, J) > Cur_Max) then
                  Cur_I := I;
                  Cur_J := J;
                  D := RD;
                  Cur_Max := Right_Diag (M, I, J);
               end if;
	    end if;
	    -- Left_diag
            if (I + 3 <= M'Last(1) and J - 3 >= M'First(2)) then
               if (Left_Diag(M, I, J) > Cur_Max) then
                  Cur_I := I;
                  Cur_J := J;
                  D := LD;
                  Cur_Max := Left_diag (M, I, J);
               end if;
	    end if;
	    -- Column
            if (I + 3 <= M'Last(1)) then
               if (Column(M, I, J) > Cur_Max) then
                  Cur_I := I;
                  Cur_J := J;
                  D := DOWN;
                  Cur_Max := Column (M, I, J);
               end if;
            end if;
	    -- Line
	    if (J + 3 <= M'Last (2)) then
               if (Line(M, I, J) > Cur_Max) then
                  Cur_I := I;
                  Cur_J := J;
                  D := RIGHT;
                  Cur_Max := Line (M, I, J);
               end if;
            end if;
         end loop;
      end loop;
      return Cur_Max;
   end;

end PE11_Max4;
